﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinCalcManager;
using System.Diagnostics;

namespace WinGridCrossgridFromula
{
    public partial class Form1 : Form
    {
        Dictionary<UltraGridCell, UltraGridCell> relatedCels = new Dictionary<UltraGridCell, UltraGridCell>();

        public Form1()
        {
            InitializeComponent();
        }

        private DataSet Generate()
        {
            Random rnd = new Random();
            DataTable[] tables = new DataTable[2];

            for (int i = 0; i < 2; i++)
            {
                tables[i] = new DataTable();
                tables[i].Columns.Add("ID", typeof(int)).AutoIncrement = true; 
                tables[i].Columns.Add("FID", typeof(int));
                tables[i].Columns.Add("Num", typeof(int));
                tables[i].Columns.Add("Col1", typeof(string)).DefaultValue = "Text table1";

            }

            for (int i1 = 0; i1 < 5; i1++)
            {
                tables[0].Rows.Add(null, i1,rnd.Next(1,100));
                int key0 = (int)tables[0].Rows[i1].ItemArray[0];

                for (int i2 = 0; i2 < 5; i2++)
                {
                    tables[1].Rows.Add(null, key0, rnd.Next(1, 100));
                    int key1 = (int)tables[1].Rows[tables[1].Rows.Count - 1].ItemArray[0];
                }
            }

            DataSet ret = new DataSet();
            ret.Tables.AddRange(tables);


            for (int i = 1; i > 0; i--)
                ret.Relations.Add(ret.Tables[i - 1].Columns["ID"], ret.Tables[i].Columns["FID"]);
            
            return ret;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = Generate();
            UltraGridRow row = ultraGrid2.DisplayLayout.Bands[0].AddNew();
            row.Cells[0].Value = "Total of Band0 Num cells";
            
            foreach (UltraGridRow srow in ultraGrid1.Rows)
            {
                UltraGridRow testrow = ultraGrid2.DisplayLayout.Bands[1].AddNew();
                if (!relatedCels.Keys.Contains(srow.Cells[4]))
                    relatedCels.Add(srow.Cells["UnboundColumn1"], testrow.Cells[1]);
            }
            
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["ID"].Hidden = true;
            e.Layout.Bands[0].Columns["FID"].Hidden = true;
            e.Layout.Bands[1].Columns["ID"].Hidden = true;
            e.Layout.Bands[1].Columns["FID"].Hidden = true;
          
        }

        private void ultraGrid2_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            //e.Layout.Bands[0].Columns[1].Formula = "Sum([//ultarGrid1/Band 0/Null])";
        }

        private void ultraGrid1_AfterCellUpdate(object sender, CellEventArgs e)
        {
            if (e.Cell.Column.Key == "UnboundColumn1")
            {
                relatedCels[e.Cell].Value = e.Cell.Value;
                relatedCels[e.Cell].Row.Cells[0].Value = "Total for " + (string) e.Cell.Row.Cells["Col1"].Value;
            }
        }

        private void ultraGrid1_AfterColRegionScroll(object sender, ColScrollRegionEventArgs e)
        {
            ultraGrid2.DisplayLayout.ColScrollRegions[0].Position =
            e.ColScrollRegion.Position;
        }

        private void ultraGrid2_AfterColRegionScroll(object sender, ColScrollRegionEventArgs e)
        {
            ultraGrid1.DisplayLayout.ColScrollRegions[0].Position =
            e.ColScrollRegion.Position;
        }

        
    }
}
